// NOTBDlg.cpp : implementation file
//

#include "stdafx.h"
#include "NOTB.h"
#include "NOTBDlg.h"
#include "time.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNOTBDlg dialog

CNOTBDlg::CNOTBDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNOTBDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNOTBDlg)
	m_Name = _T("");
	m_Number = 0;
	m_Solutions = _T("");
	m_Verbose = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON1);
}

void CNOTBDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNOTBDlg)
	DDX_Control(pDX, IDC_NAME, m_NameCtl);
	DDX_Control(pDX, IDC_NUMBER, m_NumberCtl);
	DDX_Control(pDX, IDC_SOLUTIONS, m_SolutionsCtl);
	DDX_Text(pDX, IDC_NAME, m_Name);
	DDX_Text(pDX, IDC_NUMBER, m_Number);
	DDX_Text(pDX, IDC_SOLUTIONS, m_Solutions);
	DDX_Check(pDX, IDC_VERBOSE, m_Verbose);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNOTBDlg, CDialog)
	//{{AFX_MSG_MAP(CNOTBDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_GENERATE, OnGenerate)
	ON_BN_CLICKED(IDOK, OnOK2)
	ON_BN_CLICKED(IDC_VERBOSE, OnVerbose)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNOTBDlg message handlers

BOOL CNOTBDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
    m_Number = 666;
    UpdateData(PUT);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CNOTBDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNOTBDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CNOTBDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CNOTBDlg::OnGenerate() 
{
    int 
        iNameLength = 0,
        iSuccesses = 0,
        iTotal = 0,
        iAlphaTotal = 0,
        iAlphaCount = 0,
        iWhiteSpaceTotal = 0,
        iRomanTotal = 0,
        iExtraRomanTotal = 0,
		iScrabbleTotal = 0,
        iTest = 0,
        iSolutionCount = 0,
        i = 0;
    double
        dTimeElapsed = 0,
        dTest = 0;
    clock_t
        clStart = clock();
    CString
        membuff,
        m_NameTemp,
        m_NameOld;

    UpdateData(GET);
    m_Solutions = "One Moment...";
    UpdateData(PUT);

    iNameLength = m_Name.GetLength();
    m_NameOld = m_Name;
    m_Name.MakeUpper();

    for (i=0; i<iNameLength; i++)
    {
        iTotal += m_Name[i];
        if (m_Name[i] >= 65 && m_Name[i] <= 90)
        {
            iAlphaTotal += m_Name[i];
            iAlphaCount++;
        }
        if (m_Name[i] == 32 || m_Name[i] == 9 || m_Name[i] == 13 || m_Name[i] == 10)
        {
            iWhiteSpaceTotal += m_Name[i];
        }
        iRomanTotal += Romanize(m_Name[i]);
        iExtraRomanTotal += ExtraRomanize(m_Name[i]);
		iScrabbleTotal += Scrabblize(m_Name[i]);
    }

    m_Solutions = "";
    // Do the numerical values of the letters add up?
    if ( (iTest =(iAlphaTotal - 64*iAlphaCount)) == m_Number)
    {
        membuff.Format("%i. Add the values of each letter [A = 1, B = 2, ..., Z = 26] and you get %i.", ++iSolutionCount, m_Number);
        m_Solutions += membuff + char(13) + char(10);
    }
	else if ( Divides(iAlphaCount, m_Number - iTest) ) 
    {
        iTest = int((m_Number - iTest)/double(iAlphaCount));
        membuff.Format("%i. Add %i to the value of each letter [A = %i, B = %i, ..., Z = %i] and you get %i.", ++iSolutionCount, iTest, iTest+1, iTest+2, iTest+26,m_Number);
        m_Solutions += membuff + char(13) + char(10);
    }
    else if( m_Verbose)
    {
        iTest =(iAlphaTotal - 64*iAlphaCount);
        membuff.Format("Fail: Add the values of each letter [A = 1, B = 2, ..., Z = 26] and you get %i.", iTest);
        m_Solutions += membuff + char(13) + char(10);
    }

	if ( Divides(iAlphaTotal - 64*iAlphaCount, m_Number) )
	{
        membuff.Format("%i. Add the values of each letter [A = 1, B = 2, ..., Z = 26] and multiply by %i to get %i.", ++iSolutionCount, int(m_Number / double(iAlphaTotal - 64*iAlphaCount)), m_Number);
        m_Solutions += membuff + char(13) + char(10);
	}

    if ( iAlphaTotal == m_Number )
    {
        membuff.Format("%i. Add the ASCII values of each letter (uppercase) and you get %i,", ++iSolutionCount, m_Number);
        m_Solutions += membuff + char(13) + char(10);
    }
    else if ( iWhiteSpaceTotal && (iTest = iTotal - iWhiteSpaceTotal) == m_Number)
    {
        membuff.Format("%i. Add the ASCII values of each character (excluding whitespace) and you get %i.", ++iSolutionCount, m_Number);
        m_Solutions += membuff + char(13) + char(10);
    }
    else if ( iTotal == m_Number)
    {
        membuff.Format("%i. Add the ASCII values of each character (including whitespace) and you get %i.", ++iSolutionCount, m_Number);
        m_Solutions += membuff + char(13) + char(10);
    }
    else if( m_Verbose)
    {
        membuff.Format("Fail: Add the ASCII values for each letter (uppercase) and you get %i,", iAlphaTotal, m_Number);
        m_Solutions += membuff + char(13) + char(10);
        membuff.Format("Fail: Add the ASCII values for each letter (excluding whitespace) and you get %i.", iTotal - iWhiteSpaceTotal);
        m_Solutions += membuff + char(13) + char(10);
        membuff.Format("Fail: Add the ASCII values for each letter (including whitespace) and you get %i.", iTotal);
        m_Solutions += membuff + char(13) + char(10);
    }

	if ( Divides(iAlphaTotal, m_Number) )
    {
        membuff.Format("%i. Add the ASCII values of each letter (uppercase), multiply by %i, and you get %i,", ++iSolutionCount, int(m_Number/iAlphaTotal), m_Number);
        m_Solutions += membuff + char(13) + char(10);
    }
	iTest = (iTest = iTotal - iWhiteSpaceTotal);
	if ( Divides(iTest, m_Number) )
    {
        membuff.Format("%i. Add the ASCII values of each character (excluding whitespace), multiply by %i, and you get %i.", ++iSolutionCount, int(m_Number/double(iTest)), m_Number);
        m_Solutions += membuff + char(13) + char(10);
    }
	if ( Divides(iTotal, m_Number) )
    {
        membuff.Format("%i. Add the ASCII values of each character (including whitespace), multiply by %i, and you get %i.", ++iSolutionCount, int(m_Number/iTotal), m_Number);
        m_Solutions += membuff + char(13) + char(10);
    }

    if (iRomanTotal == m_Number)
    {
        membuff.Format("%i. Take all letters that are also Roman numerals, add them together and you get %i.", ++iSolutionCount, m_Number);
        m_Solutions += membuff + char(13) + char(10);
    }
    else if (iExtraRomanTotal && iRomanTotal + iExtraRomanTotal == m_Number)
    {
        m_NameTemp = m_Name;
        m_NameTemp.Replace("W", "VV");
        m_NameTemp.Replace('U', 'V');
        m_NameTemp.Replace('J', 'I');
        membuff.Format("%i. Convert to Roman alphabet (\"", ++iSolutionCount);
        m_Solutions += membuff + m_NameTemp;
        membuff.Format("\"),%c%c   take all the letters that are also Roman numerals, add them together, and you get %i.", char(13), char(10), m_Number);
        m_Solutions += membuff + char(13) + char(10);
    }
    else if (m_Verbose)
    {
        membuff.Format("Fail: Take all the letters that are also Roman numerals and add them together and you get %i.", iRomanTotal);
        m_Solutions += membuff + char(13) + char(10);
        m_NameTemp = m_Name;
        m_NameTemp.Replace("W", "VV");
        m_NameTemp.Replace('U', 'V');
        m_NameTemp.Replace('J', 'I');
        membuff.Format("Fail: Convert to Roman alphabet (\"");
        m_Solutions += membuff + m_NameTemp;
        membuff.Format("\"),%c%c   take all the letters that are also Roman numerals, and add them together and you get %i.", char(13), char(10), iRomanTotal + iExtraRomanTotal);
        m_Solutions += membuff + char(13) + char(10);
    }

	if ( Divides(iRomanTotal, m_Number) )
    {
        membuff.Format("%i. Take all letters that are also Roman numerals, add them together, multiply by %i, and you get %i.", ++iSolutionCount, int(m_Number/iRomanTotal), m_Number);
        m_Solutions += membuff + char(13) + char(10);
    }
	iTest = iRomanTotal + iExtraRomanTotal;
	if ( Divides(iTest, m_Number) )
    {
        m_NameTemp = m_Name;
        m_NameTemp.Replace("W", "VV");
        m_NameTemp.Replace('U', 'V');
        m_NameTemp.Replace('J', 'I');
        membuff.Format("%i. Convert to Roman alphabet (\"", ++iSolutionCount);
        m_Solutions += membuff + m_NameTemp;
        membuff.Format("\"),%c%c   take all the letters that are also Roman numerals, add them together, multiply by %i, and you get %i.", char(13), char(10), int(m_Number/double(iTest)), m_Number);
        m_Solutions += membuff + char(13) + char(10);
    }

    if (iScrabbleTotal == m_Number)
    {
        membuff.Format("%i. Add the tile values of the letters from the board game Scrabble(r), add them together, and you get %i.", ++iSolutionCount, m_Number);
        m_Solutions += membuff + char(13) + char(10);
    }
	else if ( Divides(iScrabbleTotal, m_Number) )
	{
        membuff.Format("%i. Add the tile values of the letters from the board game Scrabble(r), add them together,%c%c   multiply by %i, and you get %i.", ++iSolutionCount, char(13), char(10), int(m_Number/iScrabbleTotal), m_Number);
        m_Solutions += membuff + char(13) + char(10);
	}
	else if ( m_Verbose )
	{
        membuff.Format("Fail: Add the tile values of the letters from the board game Scrabble(r), add them together, and you get %i.", iScrabbleTotal);
        m_Solutions += membuff + char(13) + char(10);
	}

    m_NameTemp = m_Name;
    m_NameTemp.TrimRight();
    iTest = m_NameTemp.ReverseFind(' ');
    if (iTest > 0 && m_NameTemp.GetLength() > iTest + 1)
    {
        m_NameTemp = m_NameTemp.Mid(iTest + 1);
        if (m_NameTemp == m_NameTemp.SpanIncluding("MDCLXVI"))
        {
            iTest = CountValue(m_NameTemp, false);
            if (iAlphaTotal - iTest + CountValue(m_NameTemp, true) == m_Number)
            {
                membuff.Format("%i. Add the ASCII values of each letter to the Roman numeral suffix and you get %i", ++iSolutionCount, m_Number);
                m_Solutions += membuff + char(13) + char(10);
            }
            else if (m_Verbose)
            {
                membuff.Format("Fail: Add the ASCII values of each letter to the Roman numeral suffix and you get %i", iAlphaTotal - iTest + CountValue(m_NameTemp, true));
                m_Solutions += membuff + char(13) + char(10);
            }
        }
    }
    

    iTest = m_Number - iAlphaTotal;
    dTest = iTest / 64.0;
    if (dTest == int(dTest) && dTest <= iAlphaCount && dTest > 0)
    {
        membuff.Format("%i. Make exactly %i of the letters lowercase and the rest uppercase,%c%c    and the ASCII values add up to %i.", ++iSolutionCount, int(dTest), char(13), char(10), m_Number);
        m_Solutions += membuff + char(13) + char(10);
    }
    
    if (iSolutionCount == 1)
    {
        membuff.Format("Number of the Beast found 1 solution.");
        m_Solutions += CString("") + char(13) + char(10) + membuff + char(13) + char(10);
    }
    else if (iSolutionCount > 1)
    {
        membuff.Format("Number of the Beast found %i solutions.", iSolutionCount);
        m_Solutions += CString("") + char(13) + char(10) + membuff + char(13) + char(10);
    }
    else 
    {
        if (m_Verbose)
        {
            m_Solutions += CString(char(13)) + char(10);
        }
//        membuff.Format("%c%cSorry, Number of the Beast was unable to find any solutions for \"%s\".", char(13), char(10), m_NameOld);
        membuff.Format("Sorry, Number of the Beast was unable to find any solutions for \"%s\".", m_NameOld);
        m_Solutions += membuff + char(13) + char(10);
    }

// **************************************************
// This is where all the "Easter Eggs" are located.  In the true source,
//    there is a list of hard-coded responses to certain queries, but
//    I'm not going to reveal them to you here.  :^)
    if (m_Name == "")
    {
        m_Solutions += CString("") + char(13) + char(10);
    }
//  else if ...
// **************************************************

    m_Name = m_NameOld;
    UpdateData(PUT);
}

int CNOTBDlg::Romanize(char c)
{
    if (c == 'm' || c == 'M')
    {
        return 1000;
    }
    else if (c == 'd' || c == 'D')
    {
        return 500;
    }
    else if (c == 'c' || c == 'C')
    {
        return 100;
    }
    else if (c == 'l' || c == 'L')
    {
        return 50;
    }
    else if (c == 'x' || c == 'X')
    {
        return 10;
    }
    else if (c == 'v' || c == 'V')
    {
        return 5;
    }
    else if (c == 'i' || c == 'I')
    {
        return 1;
    }
    else
    {
        return 0;
    }
}

int CNOTBDlg::ExtraRomanize(char c)
{
    if (c == 'j' || c == 'J')
    {
        return 1;
    }
    if (c == 'u' || c == 'U')
    {
        return 5;
    }
	if (c == 'w' || c == 'W')
	{
		return 10;
	}
    else
    {
        return 0;
    }
}

int CNOTBDlg::Divides(int x, int y)
{
	if (x && y / double(x) == int(y / double(x)) && y / x > 1)
	{
		return true;
	}
	else
	{
		return false;
	}
}

void CNOTBDlg::OnOK()
{
}

void CNOTBDlg::OnOK2() 
{
    CDialog::OnOK();
}

void CNOTBDlg::OnVerbose() 
{
	// TODO: Add your control notification handler code here
	
}

int CNOTBDlg::CountValue(CString string, bool roman)
{
    int
        i = 0,
        total = 0,
        romantotal = 0;
    char
        c = 0;

    for (i=0; i<string.GetLength(); i++)
    {
        total += string[i];
        c = string[i];

        if (c == 'm' || c == 'M')
        {
            romantotal += 1000;
        }
        else if (c == 'd' || c == 'D')
        {
            romantotal += 500;
        }
        else if (c == 'c' || c == 'C')
        {
            romantotal += 100;
        }
        else if (c == 'l' || c == 'L')
        {
            romantotal += 50;
        }
        else if (c == 'x' || c == 'X')
        {
            romantotal += 10;
        }
        else if (c == 'v' || c == 'V')
        {
            romantotal += 5;
        }
        else if (c == 'i' || c == 'I')
        {
            romantotal += 1;
        }
    }

    if (roman)
    {
        return romantotal;
    }
    else
    {
        return total;
    }
}

int CNOTBDlg::Scrabblize(char c)
{
	if (c == 'A' || c == 'E' || c == 'I' || c == 'L' || c == 'N' || 
		c == 'O' || c == 'R' || c == 'S' || c == 'T' || c == 'U')
	{
		return 1;
	}
	else if (c == 'D' || c == 'G')
	{
		return 2;
	}
	else if (c == 'B' || c == 'C' || c == 'M' || c == 'P')
	{
		return 3;
	}
	else if (c == 'F' || c == 'H' || c == 'V' || c == 'W' || c == 'Y')
	{
		return 4;
	}
	else if (c == 'K')
	{
		return 5;
	}
	else if (c == 'J' || c == 'X')
	{
		return 8;
	}
	else if (c == 'Q' || c == 'Z')
	{
		return 10;
	}
	else
	{
		return 0;
	}
}